<?php
/**
 * Pagadito.
 * 
 * Pagadito Payment Method v1.0.0
 * 
 * Este programa es Software Libre: Usted puede redistribuirlo y/o modificarlo
 * bajo los terminos de la Licencia Publica General Reducida de GNU (GNU Lesser
 * Public Licence), tal como se encuentra publicada por la Free Software
 * Foundation, ya sea por su version 3 o cualquier otra version superior.
 * 
 * Este programa es distribuido en el espiritu de que sea util, pero SIN NINGUNA
 * GARANTIA; sin tampoco garantia implicita de MERCANTIBILIDAD o ADAPTABILIDAD
 * PARA UN USO PARTICULAR. Vea la licencia GNU LGPL para mayores detalles.
 * 
 * @category    Local
 * @package     Pagadito_MPGC
 * @copyright   Copyright (c) 2012 - Pagadito, S. de R.L. (https://www.pagadito.com)
 * @license     http://www.gnu.org/licenses/lgpl.html
 * @author      Pagadito Development Team <developers@pagadito.com>
 */
class Pagadito_MPGC_Model_Config
{
    const PG_URL_SB = 'https://sandbox.pagadito.com/comercios/apipg/charges.php';
    const PG_URL_PR = 'https://comercios.pagadito.com/apipg/charges.php';
    protected $pg_url;
    protected $uid;
    protected $wsk;
    protected $sandbox;
    protected $currency;
    protected $taxName;


    public function __construct(){
        $sandbox = Mage::getStoreConfig('payment/mpgc/sandbox');
        $this->currency = Mage::getStoreConfig('payment/mpgc/pg_currency');
        $this->taxName = Mage::getStoreConfig('payment/mpgc/pg_taxName');
        
        if($sandbox == 0){
            $this->pg_url = self::PG_URL_PR;
            $this->uid = Mage::getStoreConfig('payment/mpgc/pg_uid');
            $this->wsk = Mage::getStoreConfig('payment/mpgc/pg_wsk');
            $this->sandbox = false;
        }else{
            $this->pg_url = self::PG_URL_SB;
            $this->uid = Mage::getStoreConfig('payment/mpgc/pg_sandboxuid');
            $this->wsk = Mage::getStoreConfig('payment/mpgc/pg_sandboxwsk');
            $this->sandbox = true;
        }
    }
    
    public function getPGURL(){
        return $this->pg_url;
    }
    
    public function getUID(){
        return $this->uid;
    }
    
    public function getWSK(){
        return $this->wsk;
    }
    
    public function getCurrency(){
        return $this->currency;
    }
    
    public function getTaxName(){
        return $this->taxName;
    }
    
    public function sandbox_mode(){
        return $this->sandbox;
    }
}
?>
