<?php
/**
 * Pagadito.
 * 
 * Pagadito Payment Method v1.0.0
 * 
 * Este programa es Software Libre: Usted puede redistribuirlo y/o modificarlo
 * bajo los terminos de la Licencia Publica General Reducida de GNU (GNU Lesser
 * Public Licence), tal como se encuentra publicada por la Free Software
 * Foundation, ya sea por su version 3 o cualquier otra version superior.
 * 
 * Este programa es distribuido en el espiritu de que sea util, pero SIN NINGUNA
 * GARANTIA; sin tampoco garantia implicita de MERCANTIBILIDAD o ADAPTABILIDAD
 * PARA UN USO PARTICULAR. Vea la licencia GNU LGPL para mayores detalles.
 * 
 * @category    Local
 * @package     Pagadito_MPGC
 * @copyright   Copyright (c) 2012 - Pagadito, S. de R.L. (https://www.pagadito.com)
 * @license     http://www.gnu.org/licenses/lgpl.html
 * @author      Pagadito Development Team <developers@pagadito.com>
 */
class Pagadito_MPGC_Model_Observer
{
    public function automaticallyInvoiceCompleteOrder($observer)
    {
        $session = Mage::getSingleton('customer/session');
        $orderId = $session->getPagaditoOrderId();
        $session->unsPagaditoOrderId();
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($orderId);
        $order = Mage::getModel('sales/order')
                ->loadByIncrementId($orderId);
 
        $orders = Mage::getModel('sales/order_invoice')->getCollection()
                        ->addAttributeToFilter('order_id', array('eq'=>$order->getId()));
        $orders->getSelect()->limit(1); 
 
        if ((int)$orders->count() !== 0) {
            return $this;
        }
 
        if ($order->getState() == Mage_Sales_Model_Order::STATE_NEW) {
 
            try {
                if(!$order->canInvoice()) {
                    $order->addStatusHistoryComment('PG: No se puede generar invoice a la orden.', false);
                    $order->save();
                }
 
                $invoice = Mage::getModel('sales/service_order', $order)->prepareInvoice();
 
                $invoice->setRequestedCaptureCase(Mage_Sales_Model_Order_Invoice::CAPTURE_OFFLINE);
                $invoice->register();
 
                $invoice->getOrder()->setCustomerNoteNotify(true);
                $invoice->getOrder()->setIsInProcess(true);
                $order->addStatusHistoryComment('Invoice automatico Pagadito.', false);
 
                $transactionSave = Mage::getModel('core/resource_transaction')
                    ->addObject($invoice)
                    ->addObject($invoice->getOrder());
 
                $transactionSave->save();
            } catch (Exception $e) {
                $order->addStatusHistoryComment('PG: Una excepcion ocurrio durante automaticallyInvoiceCompleteOrder action. Mensaje: '.$e->getMessage(), false);
                $order->save();
            }
        }
 
    return $this;
    }
}
?>
