<?php
/**
 * Pagadito.
 * 
 * Pagadito Payment Method v1.0.0
 * 
 * Este programa es Software Libre: Usted puede redistribuirlo y/o modificarlo
 * bajo los terminos de la Licencia Publica General Reducida de GNU (GNU Lesser
 * Public Licence), tal como se encuentra publicada por la Free Software
 * Foundation, ya sea por su version 3 o cualquier otra version superior.
 * 
 * Este programa es distribuido en el espiritu de que sea util, pero SIN NINGUNA
 * GARANTIA; sin tampoco garantia implicita de MERCANTIBILIDAD o ADAPTABILIDAD
 * PARA UN USO PARTICULAR. Vea la licencia GNU LGPL para mayores detalles.
 * 
 * @category    Local
 * @package     Pagadito_MPGC
 * @copyright   Copyright (c) 2012 - Pagadito, S. de R.L. (https://www.pagadito.com)
 * @license     http://www.gnu.org/licenses/lgpl.html
 * @author      Pagadito Development Team <developers@pagadito.com>
 */
class Pagadito_MPGC_MpgcController extends Mage_Core_Controller_Front_Action {        
    public function indexAction() {
        Mage::log("PG: acceso restringido al index del modulo frontend");
        echo '
            <html>
                <body>
                    <p>Acceso restringido</p>
                </body>
            </html>';
    }
    
    public function redirectAction(){
        $mpgc = Mage::getModel("mpgc/paymentLogic");
        $session = Mage::getSingleton('customer/session');
        $url = $session->getRedirectUrl();
        $quoteId = $session->getPagaditoQuoteId();
        $orderId = $session->getPagaditoOrderId();
        $session->unsRedirectUrl();
        $session->unsPagaditoQuoteId();
        $session->unsPagaditoOrderId();
        
        if($url == "checkout/cart"){
            $mpgc->cancelOrder($orderId);
            
            $sessionck = Mage::getSingleton('checkout/session');
            $sessionck->setQuoteId($quoteId);
            Mage::getSingleton('checkout/session')->getQuote()->setIsActive(true)->save();
            
            $this->_redirect('checkout/cart');
        }
        
        $mpgc->pendingOrder($orderId);
        
        echo
        '<html>
            <body>
                <script>document.location.href="'.$url.'";</script>
                <p>Redireccionando a pagadito, si despues de 3 segundos no redirecciona autom&aacute;ticamente, haga <a href="'.$url.'">click aqu&iacute;</a>.</p>
                <meta http-equiv="refresh" content="3;url='.$url.'">
            </body>
        </html>';
    }
    
    public function returnAction(){
        $params = $this->getRequest()->getParams();
        $order = null;
        
        $mpgc = Mage::getModel("mpgc/paymentLogic");
        
        if(!isset($params['p'])){
            Mage::log("PG: token no recibido");
            header("Location: index.php");
            exit;
        }
        
        if($mpgc->processTransacction($params['p'], $order)){
            $mpgc->completeOrder($order);
            Mage::getSingleton('core/session')->addSuccess("Pago realizado con &eacute;xito, &iexcl;Gracias por utilizar Pagadito!.");
            $session = Mage::getSingleton('customer/session');
            $session->setPagaditoOrderId($order['Id']);
            /****************************************/
            $session = Mage::getSingleton('checkout/session');
            $session->setQuoteId($session->getPagaditoQuoteId(true));
            Mage::getSingleton('checkout/session')->getQuote()->setIsActive(false)->save();
            $this->_redirect('checkout/onepage/success', array('_secure'=>true));
            /****************************************/
        }else{
            $session = Mage::getSingleton('checkout/session');
            $session->setQuoteId($order['Id']);
            Mage::log("PG: NO pudo procesar transaccion ".$params['p']);
            if($order['Id'] !== null){
                $mpgc->cancelOrder($order['Id']);
            }else{
                Mage::log("PG: orderId es nulo, no se puede cancelar la orden ".$order['Id']);
            }
            $this->_redirect('checkout/cart', array('_secure'=>true));
        }
    }
}

?>
